/* 
original formula)
dot:= mov(tp(),1,s);
{ white dots - typical price }

FST:=REF((WILDERS(TP(),5)),-3);
{ white line - shifted 3 periods forward }
SLW:=REF((WILDERS(TP(),13)),-8);
{ yellow line - shifted 8 periods forward }

*/

#property indicator_chart_window
#property indicator_buffers 2

#property indicator_color1 Aqua
#property indicator_color2 Yellow


//---- input parameters

//---- buffers

double FAST[];
double SLOW[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(2);

   
//---- indicator lines
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,FAST);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexBuffer(1,SLOW);
   SetIndexShift(0,3);
   SetIndexShift(1,8);
//---- name for DataWindow and indicator subwindow label
   short_name="Fast/Slow Stop";
   IndicatorShortName(short_name);
   
//----
   SetIndexDrawBegin(0,100);

    ObjectCreate("7",OBJ_LABEL,0,10,10);
    ObjectSet("7",OBJPROP_XDISTANCE,2);
    ObjectSet("7",OBJPROP_YDISTANCE,27);
    ObjectSet("7",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("7","More free good indicators to go FX141 download FX141.COM",11,"SimSun",Yellow);


    ObjectCreate("9",OBJ_LABEL,0,10,10);
    ObjectSet("9",OBJPROP_XDISTANCE,2);
    ObjectSet("9",OBJPROP_YDISTANCE,12);
    ObjectSet("9",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("9","Indicator Source FX141 Network Free Download FX141.COM",11,"SimSun",DeepPink);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Fast/Slow Stop                                     
//+------------------------------------------------------------------+
int start()
 {
   int    i,k,counted_bars=IndicatorCounted();
   
   if(Bars<=25) return(0);
//---- initial zero
/* 
  if(counted_bars<1)
     {
      for(i=1;i<=CCIPeriod;i++) CCIBuffer[Bars-i]=0.0;
      for(i=1;i<=CCIPeriod;i++) DevBuffer[Bars-i]=0.0;
      for(i=1;i<=CCIPeriod;i++) MovBuffer[Bars-i]=0.0;
     }
*/
//---- last counted bar will be recounted
   int limit=Bars-counted_bars;
   if (counted_bars>0) limit++; else limit-=25;
//---- dot:= mov(tp(),1,s);
   
   

    
//---- FST:=REF((WILDERS(TP(),5)),-3);
//---- { - Shifted 3 bars forward}
   for(i=0; i<limit; i++)
      FAST[i]=iMA(NULL,0,9,0,MODE_EMA,PRICE_TYPICAL,i);
      
//SLW:=REF((WILDERS(TP(),13)),-8);
//{ - shifted 8 
   for(i=0; i<limit; i++)
      SLOW[i]=iMA(NULL,0,25,0,MODE_EMA,PRICE_TYPICAL,i);
      
return(0);
}