


#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_maximum 1
#property indicator_minimum 0
//---- input parameters


double BOPu[];
double BOPd[];
double bull[];
double bear[];
double pbullsec[];
double pbearsec[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(6);
//---- name for DataWindow and indicator subwindow label


//----
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexBuffer(0, BOPu);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexBuffer(1, BOPd);
   SetIndexBuffer(2, bull);
   SetIndexBuffer(3, bear);
   SetIndexBuffer(4, pbullsec);
   SetIndexBuffer(5, pbearsec);
   short_name="Balance Of Power";
   IndicatorShortName(short_name);

    ObjectCreate("7",OBJ_LABEL,0,10,10);
    ObjectSet("7",OBJPROP_XDISTANCE,2);
    ObjectSet("7",OBJPROP_YDISTANCE,27);
    ObjectSet("7",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("7","More free good indicators to go FX141 download FX141.COM",11,"SimSun",Yellow);


    ObjectCreate("9",OBJ_LABEL,0,10,10);
    ObjectSet("9",OBJPROP_XDISTANCE,2);
    ObjectSet("9",OBJPROP_YDISTANCE,12);
    ObjectSet("9",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("9","Indicator Source FX141 Network Free Download FX141.COM",11,"SimSun",DeepPink);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Balance of Power                                                 |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double r1,r2;
   
   if(Bars<=20) return(0);
//---- initial zero

//---- last counted bar will be recounted
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;


   double pbull,pbear;
   for(i=0; i<limit; i++)
     {
         if(Close[i+1]<Open[i])
         {
            r1=MathMax(Open[i]-Close[i+1],High[i]-Low[i]);
         }
         else
         {
            r1=High[i]-Low[i];
         }
         
         if(Close[i+1]>Open[i])
         {
            r2=MathMax(Close[i+1]-Open[i],High[i]-Low[i]);
         }
         else
         {
            r2=High[i]-Low[i];
         }
         
         if(Close[i]==Open[i]){
            if((High[i]-Close[i])==(Close[i]-Low[i])){
               if(Close[i+1]>Open[i]){bull[i]=MathMax(High[i]-Open[i],Close[i]-Low[i]);}
               else {bull[i]=r1;}
            }
            else{
            if ((High[i]-Close[i])>(Close[i]-Low[i])){
               if(Close[i+1]<Open[i]){bull[i]=MathMax(High[i]-Close[i+1],Close[i]-Low[i]);}
               else {bull[i]=High[i]-Open[i];}
            }
            else{bull[i]=r1;}
            }
         }
         else{
         if (Close[i]<Open[i]){
            if (Close[i+1]<Open[i]){bull[i]=MathMax(High[i]-Close[i+1],Close[i]-Low[i]);}
            else{bull[i]=MathMax(High[i]-Open[i],Close[i]-Low[i]);}
         }
         else {bull[i]=r1;}
         }
            

         if(Close[i]==Open[i]){
            if((High[i]-Close[i])==(Close[i]-Low[i])){
               if(Close[i+1]<Open[i]){bear[i]=MathMax(Open[i]-Low[i],High[i]-Close[i]);}
               else {bear[i]=r2;}
            }
            else{
            if ((High[i]-Close[i])>(Close[i]-Low[i])){
               bear[i]=r2;
            }
            else{
               if(Close[i+1]>Open[i]){bear[i]=MathMax(Close[i+1]-Low[i],High[i]-Low[i]);}
               else {bear[i]=Open[i]-Low[i];}
            }
            }
         }
         else{
         if (Close[i]<Open[i]){
            bear[i]=r2;
         }
         else {
            if(Close[i+1]>Open[i]) {bear[i]=MathMax(Close[i+1]-Low[i],High[i]-Close[i]);}
            else {bear[i]=High[i]-Close[i];}
         }
         }       
     }
     
     for(i=0; i<limit; i++)
     {
         pbullsec[i]=iMAOnArray(bull,Bars,19,0,MODE_EMA,i);
         pbearsec[i]=iMAOnArray(bear,Bars,19,0,MODE_EMA,i);
     }
     
     for(i=0; i<limit; i++)
     {
         pbull=iMAOnArray(pbullsec,Bars,8,0,MODE_EMA,i);
         pbear=iMAOnArray(pbearsec,Bars,8,0,MODE_EMA,i);
         if (pbull>pbear){
          BOPu[i]=1;BOPd[i]=0;}
         if (pbull<pbear){
          BOPu[i]=0;BOPd[i]=1;}
     }

   return(0);
  }
//+------------------------------------------------------------------+