//+------------------------------------------------------------------+
//|                                                     PowerBar.mq4 |
//|                      Copyright ?2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Pink
#property indicator_color2 Aqua

double WBP[],VFu[],VFd[],VFn[];

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2);
   SetIndexArrow(0,108);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2);
   SetIndexArrow(1,108);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   SetIndexBuffer(2,WBP);
//----

    ObjectCreate("7",OBJ_LABEL,0,10,10);
    ObjectSet("7",OBJPROP_XDISTANCE,2);
    ObjectSet("7",OBJPROP_YDISTANCE,27);
    ObjectSet("7",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("7","More free good indicators to go FX141 download FX141.COM",11,"SimSun",Yellow);


    ObjectCreate("9",OBJ_LABEL,0,10,10);
    ObjectSet("9",OBJPROP_XDISTANCE,2);
    ObjectSet("9",OBJPROP_YDISTANCE,12);
    ObjectSet("9",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("9","Indicator Source FX141 Network Free Download FX141.COM",11,"SimSun",DeepPink);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  { 
   int    i,k,counted_bars=IndicatorCounted();
   double VF,space; space=4*MathPow(0.3,Digits);
   double T1,T2,VFprev,TPprev;
   if(Bars<=32) return(0);
   
//---- last counted bar will be recounted
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++; 

   for(i=0; i<limit-1; i++)
      {T1=(High[i]+Low[i]+Close[i])/3;T2=(High[i+1]+Low[i+1]+Close[i+1])/3;
       T1=T1-T2;WBP[i]=T1/T2*Volume[i];
       //VM[i]=13*iMA(NULL,0,13,0,MODE_SMA,MODE_VOLUME,i);
       }
    double TP;  
    for(i=0; i<limit; i++) 
   {VF=iMAOnArray(WBP,Bars,13,0,MODE_SMA,i);TP=(Close[i]+High[i]+Low[i])/3;
   VFprev=iMAOnArray(WBP,Bars,13,0,MODE_SMA,i+1);TPprev=(Close[i+1]+High[i+1]+Low[i+1])/3;
   if (VF>0 ) {VFu[i]=TP;VFd[i]=0;VFn[i]=0;}
       else if (VF<0) {VFu[i]=0;VFd[i]=TP;VFn[i]=0;}
            else {VFn[i]=TP;VFd[i]=0;VFu[i]=0;}
            
   ExtMapBuffer1[i]=0;
   ExtMapBuffer2[i]=0;
    if (VF<VFprev){
     if (Close[i]<=((High[i]-Low[i])*0.5+Low[i])){
      if (Close[i]<Open[i]){
       if (TP<TPprev){
        if (Volume[i]>Volume[i+1]){
         if ((High[i]-Low[i])/Volume[i]>(High[i+1]-Low[i+1])/Volume[i+1]){
         ExtMapBuffer1[i]=High[i]+space;

}}}}}}
   if (VF>VFprev){
     if (Close[i]>=((High[i]-Low[i])*0.5+Low[i])){
      if (Close[i]>Open[i]){
       if (TP>TPprev){
        if (Volume[i]>Volume[i+1]){
         if ((High[i]-Low[i])/Volume[i]>(High[i+1]-Low[i+1])/Volume[i+1]){
         ExtMapBuffer2[i]=Low[i]-space;

}}}}}}
}
   return(0);
  }
//+------------------------------------------------------------------+